var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx } from "react/jsx-runtime";
import ReactECharts from 'echarts-for-react';
import { useEffect, useRef } from 'react';
var BarChart = function (props) {
    var chartRef = useRef(null);
    useEffect(function () {
        var handleResize = function () {
            if (chartRef.current) {
                chartRef.current.getEchartsInstance().resize();
            }
        };
        window.addEventListener('resize', handleResize);
        return function () {
            window.removeEventListener('resize', handleResize);
        };
    }, []);
    var serials = new Set();
    var xValues = new Set();
    if (props.chartData && Array.isArray(props.chartData)) {
        props.chartData.forEach(function (item) {
            var _a, _b, _c, _d;
            serials.add(item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field]);
            xValues.add(item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field]);
        });
    }
    var getOption = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47, _48, _49, _50, _51, _52, _53, _54, _55, _56, _57, _58, _59;
        var seriField = (_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field;
        var xAxisField = (_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field;
        var yAxisField = (_f = (_e = props.setup.chart) === null || _e === void 0 ? void 0 : _e.y_axis) === null || _f === void 0 ? void 0 : _f.field;
        var datasetSource = [__spreadArray([xAxisField], Array.from(serials), true)];
        Array.from(xValues).forEach(function (xValue) {
            var row = [xValue];
            Array.from(serials).forEach(function (serial) {
                var _a, _b;
                var found = (_a = props.chartData) === null || _a === void 0 ? void 0 : _a.find(function (item) { return item[seriField] === serial && item[xAxisField] === xValue; });
                row.push((_b = found === null || found === void 0 ? void 0 : found[yAxisField]) !== null && _b !== void 0 ? _b : 0);
            });
            datasetSource.push(row);
        });
        return {
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true,
            },
            legend: {
                show: ((_h = (_g = props.setup.chart) === null || _g === void 0 ? void 0 : _g.legend) === null || _h === void 0 ? void 0 : _h.show) || false,
                orient: ((_k = (_j = props.setup.chart) === null || _j === void 0 ? void 0 : _j.legend) === null || _k === void 0 ? void 0 : _k.orient) || 'horizontal',
                left: ((_m = (_l = props.setup.chart) === null || _l === void 0 ? void 0 : _l.legend) === null || _m === void 0 ? void 0 : _m.left) || 'auto',
                right: ((_p = (_o = props.setup.chart) === null || _o === void 0 ? void 0 : _o.legend) === null || _p === void 0 ? void 0 : _p.right) || 'auto',
                top: ((_r = (_q = props.setup.chart) === null || _q === void 0 ? void 0 : _q.legend) === null || _r === void 0 ? void 0 : _r.top) || 'auto',
                bottom: ((_t = (_s = props.setup.chart) === null || _s === void 0 ? void 0 : _s.legend) === null || _t === void 0 ? void 0 : _t.bottom) || 'auto',
            },
            tooltip: {
                show: ((_v = (_u = props.setup.chart) === null || _u === void 0 ? void 0 : _u.tooltip) === null || _v === void 0 ? void 0 : _v.show) || false,
                trigger: ((_x = (_w = props.setup.chart) === null || _w === void 0 ? void 0 : _w.tooltip) === null || _x === void 0 ? void 0 : _x.trigger) || 'axis',
                axisPointer: {
                    type: 'cross',
                    crossStyle: { color: '#999' },
                },
                backgroundColor: ((_z = (_y = props.setup.chart) === null || _y === void 0 ? void 0 : _y.tooltip) === null || _z === void 0 ? void 0 : _z.backgroundColor) || '#000',
                borderRadius: ((_1 = (_0 = props.setup.chart) === null || _0 === void 0 ? void 0 : _0.tooltip) === null || _1 === void 0 ? void 0 : _1.borderRadius) || 0,
                textStyle: {
                    fontSize: ((_4 = (_3 = (_2 = props.setup.chart) === null || _2 === void 0 ? void 0 : _2.tooltip) === null || _3 === void 0 ? void 0 : _3.textStyle) === null || _4 === void 0 ? void 0 : _4.fontSize) || 'normal',
                    color: ((_7 = (_6 = (_5 = props.setup.chart) === null || _5 === void 0 ? void 0 : _5.tooltip) === null || _6 === void 0 ? void 0 : _6.textStyle) === null || _7 === void 0 ? void 0 : _7.color) || '#fff',
                    fontWeight: 'normal',
                },
            },
            dataset: {
                source: datasetSource,
            },
            xAxis: props.setup.type === 'vertical-bar-chart'
                ? __assign({ type: ((_9 = (_8 = props.setup.chart) === null || _8 === void 0 ? void 0 : _8.x_axis) === null || _9 === void 0 ? void 0 : _9.type) || 'category', axisPointer: {
                        type: 'shadow',
                    }, min: ((_11 = (_10 = props.setup.chart) === null || _10 === void 0 ? void 0 : _10.x_axis) === null || _11 === void 0 ? void 0 : _11.min) || undefined, max: ((_13 = (_12 = props.setup.chart) === null || _12 === void 0 ? void 0 : _12.x_axis) === null || _13 === void 0 ? void 0 : _13.max) || undefined, axisLabel: {
                        rotate: ((_16 = (_15 = (_14 = props.setup.chart) === null || _14 === void 0 ? void 0 : _14.x_axis) === null || _15 === void 0 ? void 0 : _15.axisLabel) === null || _16 === void 0 ? void 0 : _16.rotate) || 0,
                        formatter: ((_19 = (_18 = (_17 = props.setup.chart) === null || _17 === void 0 ? void 0 : _17.x_axis) === null || _18 === void 0 ? void 0 : _18.axisLabel) === null || _19 === void 0 ? void 0 : _19.formatter) || undefined,
                    }, splitLine: {
                        lineStyle: {
                            color: ((_23 = (_22 = (_21 = (_20 = props.setup.chart) === null || _20 === void 0 ? void 0 : _20.x_axis) === null || _21 === void 0 ? void 0 : _21.splitLine) === null || _22 === void 0 ? void 0 : _22.lineStyle) === null || _23 === void 0 ? void 0 : _23.color) || '#e9e9eb',
                            type: ((_27 = (_26 = (_25 = (_24 = props.setup.chart) === null || _24 === void 0 ? void 0 : _24.x_axis) === null || _25 === void 0 ? void 0 : _25.splitLine) === null || _26 === void 0 ? void 0 : _26.lineStyle) === null || _27 === void 0 ? void 0 : _27.type) || 'solid',
                            width: ((_31 = (_30 = (_29 = (_28 = props.setup.chart) === null || _28 === void 0 ? void 0 : _28.x_axis) === null || _29 === void 0 ? void 0 : _29.splitLine) === null || _30 === void 0 ? void 0 : _30.lineStyle) === null || _31 === void 0 ? void 0 : _31.width) || 1,
                        },
                    } }, (((_33 = (_32 = props.setup.chart) === null || _32 === void 0 ? void 0 : _32.x_axis) === null || _33 === void 0 ? void 0 : _33.type) === 'time' && {
                    minInterval: 24 * 60 * 60 * 1000,
                })) : {},
            yAxis: props.setup.type === 'vertical-bar-chart'
                ? {}
                : __assign({ type: ((_35 = (_34 = props.setup.chart) === null || _34 === void 0 ? void 0 : _34.y_axis) === null || _35 === void 0 ? void 0 : _35.type) || 'category', axisPointer: {
                        type: 'shadow',
                    }, min: ((_37 = (_36 = props.setup.chart) === null || _36 === void 0 ? void 0 : _36.y_axis) === null || _37 === void 0 ? void 0 : _37.min) || undefined, max: ((_39 = (_38 = props.setup.chart) === null || _38 === void 0 ? void 0 : _38.y_axis) === null || _39 === void 0 ? void 0 : _39.max) || undefined, axisLabel: {
                        rotate: ((_42 = (_41 = (_40 = props.setup.chart) === null || _40 === void 0 ? void 0 : _40.y_axis) === null || _41 === void 0 ? void 0 : _41.axisLabel) === null || _42 === void 0 ? void 0 : _42.rotate) || 0,
                        formatter: ((_45 = (_44 = (_43 = props.setup.chart) === null || _43 === void 0 ? void 0 : _43.y_axis) === null || _44 === void 0 ? void 0 : _44.axisLabel) === null || _45 === void 0 ? void 0 : _45.formatter) || undefined,
                    }, splitLine: {
                        lineStyle: {
                            color: ((_49 = (_48 = (_47 = (_46 = props.setup.chart) === null || _46 === void 0 ? void 0 : _46.y_axis) === null || _47 === void 0 ? void 0 : _47.splitLine) === null || _48 === void 0 ? void 0 : _48.lineStyle) === null || _49 === void 0 ? void 0 : _49.color) || '#e9e9eb',
                            type: ((_53 = (_52 = (_51 = (_50 = props.setup.chart) === null || _50 === void 0 ? void 0 : _50.y_axis) === null || _51 === void 0 ? void 0 : _51.splitLine) === null || _52 === void 0 ? void 0 : _52.lineStyle) === null || _53 === void 0 ? void 0 : _53.type) || 'solid',
                            width: ((_57 = (_56 = (_55 = (_54 = props.setup.chart) === null || _54 === void 0 ? void 0 : _54.y_axis) === null || _55 === void 0 ? void 0 : _55.splitLine) === null || _56 === void 0 ? void 0 : _56.lineStyle) === null || _57 === void 0 ? void 0 : _57.width) || 1,
                        },
                    } }, (((_59 = (_58 = props.setup.chart) === null || _58 === void 0 ? void 0 : _58.y_axis) === null || _59 === void 0 ? void 0 : _59.type) === 'time' && {
                    minInterval: 24 * 60 * 60 * 1000,
                })),
            series: Array.from(serials).map(function (value, index) {
                var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8;
                return {
                    type: 'bar',
                    itemStyle: {
                        color: ((_d = (_c = (_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.item_styles) === null || _b === void 0 ? void 0 : _b[index]) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.bg_to_color)
                            ? {
                                type: 'linear',
                                x: 0,
                                y: 0,
                                x2: 0,
                                y2: 1,
                                colorStops: [
                                    {
                                        offset: 0,
                                        color: (_j = (_h = (_g = (_f = (_e = props.setup.chart) === null || _e === void 0 ? void 0 : _e.item_styles) === null || _f === void 0 ? void 0 : _f[index]) === null || _g === void 0 ? void 0 : _g.style) === null || _h === void 0 ? void 0 : _h.bg_color) !== null && _j !== void 0 ? _j : '#5470c6',
                                    },
                                    {
                                        offset: 1,
                                        color: (_p = (_o = (_m = (_l = (_k = props.setup.chart) === null || _k === void 0 ? void 0 : _k.item_styles) === null || _l === void 0 ? void 0 : _l[index]) === null || _m === void 0 ? void 0 : _m.style) === null || _o === void 0 ? void 0 : _o.bg_to_color) !== null && _p !== void 0 ? _p : '#91cc75',
                                    },
                                ],
                            }
                            : ((_u = (_t = (_s = (_r = (_q = props.setup.chart) === null || _q === void 0 ? void 0 : _q.item_styles) === null || _r === void 0 ? void 0 : _r[index]) === null || _s === void 0 ? void 0 : _s.style) === null || _t === void 0 ? void 0 : _t.bg_color) !== null && _u !== void 0 ? _u : '#5470c6'),
                        borderRadius: (_z = (_y = (_x = (_w = (_v = props.setup.chart) === null || _v === void 0 ? void 0 : _v.item_styles) === null || _w === void 0 ? void 0 : _w[index]) === null || _x === void 0 ? void 0 : _x.style) === null || _y === void 0 ? void 0 : _y.border_radius) !== null && _z !== void 0 ? _z : 0,
                        borderColor: (_4 = (_3 = (_2 = (_1 = (_0 = props.setup.chart) === null || _0 === void 0 ? void 0 : _0.item_styles) === null || _1 === void 0 ? void 0 : _1[index]) === null || _2 === void 0 ? void 0 : _2.style) === null || _3 === void 0 ? void 0 : _3.line_color) !== null && _4 !== void 0 ? _4 : undefined,
                        borderWidth: ((_8 = (_7 = (_6 = (_5 = props.setup.chart) === null || _5 === void 0 ? void 0 : _5.item_styles) === null || _6 === void 0 ? void 0 : _6[index]) === null || _7 === void 0 ? void 0 : _7.style) === null || _8 === void 0 ? void 0 : _8.line_color) ? 2 : 0,
                    },
                };
            }),
        };
    };
    return _jsx(ReactECharts, { ref: chartRef, option: getOption(), style: { width: '100%', height: '100%' } });
};
export default BarChart;
