var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx } from "react/jsx-runtime";
import ReactECharts from 'echarts-for-react';
import { useEffect, useRef } from 'react';
import { renderColors } from '../common/utils.js';
var StackChart = function (props) {
    var chartRef = useRef(null);
    useEffect(function () {
        var handleResize = function () {
            if (chartRef.current) {
                chartRef.current.getEchartsInstance().resize();
            }
        };
        window.addEventListener('resize', handleResize);
        return function () {
            window.removeEventListener('resize', handleResize);
        };
    }, []);
    var serials = new Set();
    var xValues = new Set();
    if (props.chartData && Array.isArray(props.chartData)) {
        props.chartData.forEach(function (item) {
            var _a, _b, _c, _d;
            serials.add(item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field]);
            xValues.add(item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field]);
        });
    }
    var getOption = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35;
        return {
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true,
            },
            legend: {
                show: ((_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.legend) === null || _b === void 0 ? void 0 : _b.show) || false,
                orient: ((_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.legend) === null || _d === void 0 ? void 0 : _d.orient) || 'horizontal',
                left: ((_f = (_e = props.setup.chart) === null || _e === void 0 ? void 0 : _e.legend) === null || _f === void 0 ? void 0 : _f.left) || 'auto',
                right: ((_h = (_g = props.setup.chart) === null || _g === void 0 ? void 0 : _g.legend) === null || _h === void 0 ? void 0 : _h.right) || 'auto',
                top: ((_k = (_j = props.setup.chart) === null || _j === void 0 ? void 0 : _j.legend) === null || _k === void 0 ? void 0 : _k.top) || 'auto',
                bottom: ((_m = (_l = props.setup.chart) === null || _l === void 0 ? void 0 : _l.legend) === null || _m === void 0 ? void 0 : _m.bottom) || 'auto',
            },
            tooltip: {
                show: ((_p = (_o = props.setup.chart) === null || _o === void 0 ? void 0 : _o.tooltip) === null || _p === void 0 ? void 0 : _p.show) || false,
                trigger: ((_r = (_q = props.setup.chart) === null || _q === void 0 ? void 0 : _q.tooltip) === null || _r === void 0 ? void 0 : _r.trigger) || 'axis',
                axisPointer: {
                    type: 'cross',
                    crossStyle: {
                        color: '#999',
                    },
                },
                backgroundColor: ((_t = (_s = props.setup.chart) === null || _s === void 0 ? void 0 : _s.tooltip) === null || _t === void 0 ? void 0 : _t.backgroundColor) || '#000',
                borderRadius: ((_v = (_u = props.setup.chart) === null || _u === void 0 ? void 0 : _u.tooltip) === null || _v === void 0 ? void 0 : _v.borderRadius) || 0,
                textStyle: {
                    fontSize: ((_y = (_x = (_w = props.setup.chart) === null || _w === void 0 ? void 0 : _w.tooltip) === null || _x === void 0 ? void 0 : _x.textStyle) === null || _y === void 0 ? void 0 : _y.fontSize) || 'normal',
                    color: ((_1 = (_0 = (_z = props.setup.chart) === null || _z === void 0 ? void 0 : _z.tooltip) === null || _0 === void 0 ? void 0 : _0.textStyle) === null || _1 === void 0 ? void 0 : _1.color) || '#fff',
                    fontWeight: 'normal',
                },
            },
            dataset: {
                source: __spreadArray([
                    __spreadArray([(_3 = (_2 = props.setup.chart) === null || _2 === void 0 ? void 0 : _2.seri) === null || _3 === void 0 ? void 0 : _3.field], Array.from(serials), true)
                ], Array.from(xValues).map(function (xValue) { return __spreadArray([
                    xValue
                ], Array.from(serials).map(function (serial) {
                    var _a, _b, _c, _d;
                    return ((_b = (_a = props.chartData) === null || _a === void 0 ? void 0 : _a.find(function (item) {
                        var _a, _b, _c, _d;
                        return item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field] === serial &&
                            item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field] === xValue;
                    })) === null || _b === void 0 ? void 0 : _b[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.y_axis) === null || _d === void 0 ? void 0 : _d.field]) || 0;
                }), true); }), true),
            },
            xAxis: __assign({ type: ((_5 = (_4 = props.setup.chart) === null || _4 === void 0 ? void 0 : _4.x_axis) === null || _5 === void 0 ? void 0 : _5.type) || 'category', axisPointer: {
                    type: 'shadow',
                }, min: ((_7 = (_6 = props.setup.chart) === null || _6 === void 0 ? void 0 : _6.x_axis) === null || _7 === void 0 ? void 0 : _7.min) || undefined, max: ((_9 = (_8 = props.setup.chart) === null || _8 === void 0 ? void 0 : _8.x_axis) === null || _9 === void 0 ? void 0 : _9.max) || undefined, axisLabel: {
                    rotate: ((_12 = (_11 = (_10 = props.setup.chart) === null || _10 === void 0 ? void 0 : _10.x_axis) === null || _11 === void 0 ? void 0 : _11.axisLabel) === null || _12 === void 0 ? void 0 : _12.rotate) || 0,
                    formatter: ((_15 = (_14 = (_13 = props.setup.chart) === null || _13 === void 0 ? void 0 : _13.x_axis) === null || _14 === void 0 ? void 0 : _14.axisLabel) === null || _15 === void 0 ? void 0 : _15.formatter) || undefined,
                }, splitLine: {
                    lineStyle: {
                        color: ((_19 = (_18 = (_17 = (_16 = props.setup.chart) === null || _16 === void 0 ? void 0 : _16.x_axis) === null || _17 === void 0 ? void 0 : _17.splitLine) === null || _18 === void 0 ? void 0 : _18.lineStyle) === null || _19 === void 0 ? void 0 : _19.color) || '#e9e9eb',
                        type: ((_23 = (_22 = (_21 = (_20 = props.setup.chart) === null || _20 === void 0 ? void 0 : _20.x_axis) === null || _21 === void 0 ? void 0 : _21.splitLine) === null || _22 === void 0 ? void 0 : _22.lineStyle) === null || _23 === void 0 ? void 0 : _23.type) || 'solid',
                        width: ((_27 = (_26 = (_25 = (_24 = props.setup.chart) === null || _24 === void 0 ? void 0 : _24.x_axis) === null || _25 === void 0 ? void 0 : _25.splitLine) === null || _26 === void 0 ? void 0 : _26.lineStyle) === null || _27 === void 0 ? void 0 : _27.width) || 1,
                    },
                } }, (((_29 = (_28 = props.setup.chart) === null || _28 === void 0 ? void 0 : _28.x_axis) === null || _29 === void 0 ? void 0 : _29.type) === 'time' && {
                minInterval: 24 * 60 * 60 * 1000,
            })),
            yAxis: __assign({ type: ((_31 = (_30 = props.setup.chart) === null || _30 === void 0 ? void 0 : _30.y_axis) === null || _31 === void 0 ? void 0 : _31.type) || 'value', axisPointer: {
                    type: 'shadow',
                } }, (((_33 = (_32 = props.setup.chart) === null || _32 === void 0 ? void 0 : _32.y_axis) === null || _33 === void 0 ? void 0 : _33.type) === 'time' && {
                minInterval: 24 * 60 * 60 * 1000,
            })),
            series: Array.from(serials).map(function (value, index) {
                var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z;
                return {
                    type: props.setup.type === 'stack-area-chart' ? 'line' : 'bar',
                    stack: 'total',
                    label: {
                        show: false,
                    },
                    smooth: props.setup.type === 'stack-area-chart' ? true : false,
                    areaStyle: props.setup.type === 'stack-area-chart'
                        ? {
                            color: (_e = (_d = (_c = (_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.item_styles) === null || _b === void 0 ? void 0 : _b[index]) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.bg_color) !== null && _e !== void 0 ? _e : '#5470c6',
                            opacity: 0.3,
                        }
                        : undefined,
                    itemStyle: {
                        color: (_k = (_j = (_h = (_g = (_f = props.setup.chart) === null || _f === void 0 ? void 0 : _f.item_styles) === null || _g === void 0 ? void 0 : _g[index]) === null || _h === void 0 ? void 0 : _h.style) === null || _j === void 0 ? void 0 : _j.bg_color) !== null && _k !== void 0 ? _k : '#5470c6',
                        borderRadius: (_q = (_p = (_o = (_m = (_l = props.setup.chart) === null || _l === void 0 ? void 0 : _l.item_styles) === null || _m === void 0 ? void 0 : _m[index]) === null || _o === void 0 ? void 0 : _o.style) === null || _p === void 0 ? void 0 : _p.border_radius) !== null && _q !== void 0 ? _q : 0,
                        borderColor: (_v = (_u = (_t = (_s = (_r = props.setup.chart) === null || _r === void 0 ? void 0 : _r.item_styles) === null || _s === void 0 ? void 0 : _s[index]) === null || _t === void 0 ? void 0 : _t.style) === null || _u === void 0 ? void 0 : _u.line_color) !== null && _v !== void 0 ? _v : undefined,
                        borderWidth: ((_z = (_y = (_x = (_w = props.setup.chart) === null || _w === void 0 ? void 0 : _w.item_styles) === null || _x === void 0 ? void 0 : _x[index]) === null || _y === void 0 ? void 0 : _y.style) === null || _z === void 0 ? void 0 : _z.line_color) ? 2 : 0,
                    },
                };
            }),
            color: renderColors(((_34 = props.setup.chart) === null || _34 === void 0 ? void 0 : _34.item_styles) || [], (_35 = props.chartData) === null || _35 === void 0 ? void 0 : _35.length),
        };
    };
    return _jsx(ReactECharts, { ref: chartRef, option: getOption(), style: { width: '100%', height: '100%' } });
};
export default StackChart;
