import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import React from 'react';
import { formatValue } from '../common/utils.js';
import Pagination from '../components/Pagination.js';
var Table = function (_a) {
    var _b, _c;
    var setup = _a.setup, pageSize = _a.pageSize, chartData = _a.chartData, dataTotal = _a.dataTotal, currentPage = _a.currentPage, onPageChange = _a.onPageChange, onPageSizeChange = _a.onPageSizeChange;
    var _d = React.useState([]), dataTable = _d[0], setDataTable = _d[1];
    var _e = React.useState(currentPage), clientCurrentPage = _e[0], setClientCurrentPage = _e[1];
    var tableColumnsOption = Array.isArray((_b = setup.table) === null || _b === void 0 ? void 0 : _b.columns)
        ? (_c = setup.table) === null || _c === void 0 ? void 0 : _c.columns
        : [];
    var totalPages = Math.ceil((dataTotal > 0 ? dataTotal : chartData.length) / pageSize);
    var handleClientPageChange = function (page) {
        var _a;
        setClientCurrentPage(page);
        var startIndex = (page - 1) * pageSize;
        var endIndex = startIndex + pageSize;
        setDataTable((_a = chartData === null || chartData === void 0 ? void 0 : chartData.slice(startIndex, endIndex)) !== null && _a !== void 0 ? _a : []);
    };
    var handleClientPageSizeChange = function (newSize) {
        var _a;
        setClientCurrentPage(1);
        var startIndex = 0;
        var endIndex = startIndex + newSize;
        setDataTable((_a = chartData === null || chartData === void 0 ? void 0 : chartData.slice(startIndex, endIndex)) !== null && _a !== void 0 ? _a : []);
        onPageSizeChange === null || onPageSizeChange === void 0 ? void 0 : onPageSizeChange(newSize);
    };
    React.useEffect(function () {
        if (dataTotal === 0) {
            handleClientPageChange(currentPage);
        }
        else {
            setDataTable(chartData);
            setClientCurrentPage(currentPage);
        }
    }, [chartData, dataTotal, pageSize]);
    var caculateWidth = function (width) {
        if (!width)
            return 'auto';
        var totalWidth = tableColumnsOption.reduce(function (sum, col) { return sum + (col.width || 0); }, 0);
        return "".concat((width / totalWidth) * 100, "%");
    };
    return (_jsxs(_Fragment, { children: [_jsx("div", { className: "stable-component", children: _jsxs("table", { border: 1, style: { width: '100%', borderCollapse: 'collapse' }, children: [_jsx("thead", { children: _jsx("tr", { children: tableColumnsOption.map(function (option) { return (_jsx("th", { style: {
                                        position: 'sticky',
                                        top: 0,
                                        backgroundColor: '#f5f7fa',
                                        fontWeight: 'bold',
                                        zIndex: 1,
                                        minWidth: option.width ? "".concat(option.width, "px") : 'auto',
                                        width: caculateWidth(option.width),
                                    }, children: option.header_text || option.field }, option.field)); }) }) }), _jsx("tbody", { children: dataTable.map(function (row, indexRow) { return (_jsx("tr", { children: tableColumnsOption.map(function (option) {
                                    var _a, _b, _c, _d, _e, _f, _g, _h;
                                    return (_jsx("td", { className: "".concat(((_a = option.styles) === null || _a === void 0 ? void 0 : _a.custom_class) || ''), style: {
                                            textAlign: ((_b = option.styles) === null || _b === void 0 ? void 0 : _b.text_align) || 'left',
                                            fontStyle: ((_c = option.styles) === null || _c === void 0 ? void 0 : _c.italic) ? 'italic' : 'normal',
                                            fontWeight: ((_d = option.styles) === null || _d === void 0 ? void 0 : _d.bold) ? 'bold' : 'normal',
                                            color: (_f = (_e = option.styles) === null || _e === void 0 ? void 0 : _e.text_color) !== null && _f !== void 0 ? _f : '#000',
                                            backgroundColor: (_h = (_g = option.styles) === null || _g === void 0 ? void 0 : _g.bg_color) !== null && _h !== void 0 ? _h : '#ffffff',
                                            minWidth: option.width ? "".concat(option.width, "px") : 'auto',
                                        }, children: option.field && row[option.field] !== undefined && row[option.field] !== null
                                            ? formatValue(row[option.field], option === null || option === void 0 ? void 0 : option.format_string)
                                            : '' }, option.field));
                                }) }, indexRow)); }) })] }) }), _jsx(Pagination, { setup: setup, pageSize: pageSize, totalPages: totalPages, currentPage: dataTotal === 0 ? clientCurrentPage : currentPage, onPageChange: dataTotal === 0 ? handleClientPageChange : onPageChange, onPageSizeChange: dataTotal === 0 ? handleClientPageSizeChange : onPageSizeChange })] }));
};
export default Table;
