var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useEffect } from 'react';
import BarChart from '../charts/BarChart.js';
import LineChart from '../charts/LineChart.js';
import StackChart from '../charts/StackChart.js';
import PieChart from '../charts/PieChart.js';
import SimpleInformation from '../charts/SimpleInformation.js';
import Table from '../charts/Table.js';
import PercentChart from '../charts/PercentChart.js';
import ChartTitle from './ChartTitle.js';
import ChartSub from './ChartSub.js';
import Filter from './Filter.js';
import { downloadExcel } from './ExcelDownloader.js';
var ChartContainer = function (_a) {
    var _b, _c, _d, _e;
    var id = _a.id, setup = _a.setup, index = _a.index, configuration = _a.configuration;
    var titleRef = React.useRef(null);
    var subRef = React.useRef(null);
    var _f = React.useState(0), chartHeight = _f[0], setChartHeight = _f[1];
    var _g = React.useState(1), currentPage = _g[0], setCurrentPage = _g[1];
    var _h = React.useState('loading'), status = _h[0], setStatus = _h[1];
    var _j = React.useState([]), chartData = _j[0], setChartData = _j[1];
    var _k = React.useState([]), dataForDownloadExcel = _k[0], setDataForDownloadExcel = _k[1];
    var _l = React.useState([]), subChartData = _l[0], setSubChartData = _l[1];
    var _m = React.useState(0), dataTotal = _m[0], setDataTotal = _m[1];
    var _o = React.useState(false), isTableView = _o[0], setIsTableView = _o[1];
    var _p = React.useState(((_b = setup.table) === null || _b === void 0 ? void 0 : _b.page_size) || ((_d = (_c = setup.table) === null || _c === void 0 ? void 0 : _c.page_sizes) === null || _d === void 0 ? void 0 : _d[0]) || 10), pageSize = _p[0], setPageSize = _p[1];
    var _q = React.useState(false), isFilterVisible = _q[0], setIsFilterVisible = _q[1];
    var _r = React.useState(function () {
        return __assign({}, configuration.filterDashboard);
    }), appliedFilters = _r[0], setAppliedFilters = _r[1];
    React.useLayoutEffect(function () {
        if (!titleRef.current || !subRef.current)
            return;
        var resizeObserver = new ResizeObserver(function () {
            requestAnimationFrame(function () {
                var _a, _b;
                var container = document.getElementById(id);
                if (!container)
                    return;
                var containerRect = container.getBoundingClientRect();
                var titleRect = (_a = titleRef.current) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect();
                var subRect = (_b = subRef.current) === null || _b === void 0 ? void 0 : _b.getBoundingClientRect();
                var containerHeight = containerRect.height;
                var titleHeight = (titleRect === null || titleRect === void 0 ? void 0 : titleRect.height) || 0;
                var subHeight = (subRect === null || subRect === void 0 ? void 0 : subRect.height) ? (subRect === null || subRect === void 0 ? void 0 : subRect.height) + 6 : 0;
                var availableHeight = containerHeight - titleHeight - subHeight;
                setChartHeight(Math.max(availableHeight, 0));
            });
        });
        var container = document.getElementById(id);
        if (container) {
            resizeObserver.observe(container);
        }
        resizeObserver.observe(titleRef.current);
        resizeObserver.observe(subRef.current);
        return function () {
            resizeObserver.disconnect();
        };
    }, [id, subChartData]);
    var handleToggleViewTable = function (showTable) {
        handlePlaySound('view-table');
        setIsTableView(showTable);
    };
    var handleDashboardByLink = function (arg) {
        var _a, _b, _c;
        handlePlaySound('navigate');
        if (configuration.fnHandleDashboardLink) {
            return configuration.fnHandleDashboardLink(arg);
        }
        if ((_a = arg.target) === null || _a === void 0 ? void 0 : _a.link)
            window.location.href = (_c = (_b = arg.target) === null || _b === void 0 ? void 0 : _b.link) !== null && _c !== void 0 ? _c : '';
    };
    var handlePlaySound = function (code, value) {
        if (configuration.handleClick)
            return configuration.handleClick({ code: code, value: value });
    };
    var downloadFileExcel = function () {
        var _a;
        handlePlaySound('download-excel');
        var objectDataExcel = downloadExcel({
            data: dataForDownloadExcel,
            setupData: (_a = setup.table) !== null && _a !== void 0 ? _a : undefined,
        });
        if (configuration.fnHandleDownloadFileExcel && objectDataExcel)
            return configuration.fnHandleDownloadFileExcel(objectDataExcel);
    };
    var getDefaultFilters = function (parameters) {
        if (parameters === void 0) { parameters = []; }
        return parameters.reduce(function (acc, param) {
            if ((param === null || param === void 0 ? void 0 : param.code) && (param === null || param === void 0 ? void 0 : param.default) !== undefined) {
                acc[param.code] = param.default;
            }
            return acc;
        }, {});
    };
    var getChartDataAsync = function (arg) { return __awaiter(void 0, void 0, void 0, function () {
        var mergedFilters, defaultFilters, result, dataForExcel, resultForExcel, filteredMainData, filteredExcelData, _a;
        var _b, _c, _d, _e, _f, _g, _h, _j;
        return __generator(this, function (_k) {
            switch (_k.label) {
                case 0:
                    _k.trys.push([0, 4, 5, 6]);
                    setStatus('loading');
                    mergedFilters = {};
                    if ((_b = setup.parameters) === null || _b === void 0 ? void 0 : _b.length) {
                        defaultFilters = getDefaultFilters(((_c = setup.parameters) === null || _c === void 0 ? void 0 : _c.filter(function (param) { return param !== null && param !== undefined; })) || []);
                        mergedFilters = __assign({}, defaultFilters);
                    }
                    if (configuration.filterDashboard) {
                        mergedFilters = __assign(__assign({}, mergedFilters), configuration.filterDashboard);
                    }
                    if (Object.keys(appliedFilters).length > 0) {
                        mergedFilters = __assign(__assign({}, mergedFilters), appliedFilters);
                    }
                    return [4, configuration.fnGetChartDataAsync(__assign(__assign({}, arg), { filter: mergedFilters, limit: setup.type === 'table' ? pageSize : undefined, offset: setup.type === 'table' ? (currentPage - 1) * pageSize : undefined }))];
                case 1:
                    result = _k.sent();
                    dataForExcel = (_d = result === null || result === void 0 ? void 0 : result.data) !== null && _d !== void 0 ? _d : [];
                    if (!(setup.type === 'table')) return [3, 3];
                    return [4, configuration.fnGetChartDataAsync(__assign(__assign({}, arg), { filter: mergedFilters, limit: undefined, offset: undefined }))];
                case 2:
                    resultForExcel = _k.sent();
                    dataForExcel = (_e = resultForExcel === null || resultForExcel === void 0 ? void 0 : resultForExcel.data) !== null && _e !== void 0 ? _e : [];
                    _k.label = 3;
                case 3:
                    filteredMainData = (_g = (_f = result === null || result === void 0 ? void 0 : result.data) === null || _f === void 0 ? void 0 : _f.filter(function (item) { return item !== null && item !== undefined; })) !== null && _g !== void 0 ? _g : [];
                    filteredExcelData = (_h = dataForExcel === null || dataForExcel === void 0 ? void 0 : dataForExcel.filter(function (item) { return item !== null && item !== undefined; })) !== null && _h !== void 0 ? _h : [];
                    if (filteredMainData.length === 0) {
                        setStatus('empty');
                    }
                    else {
                        setStatus('loaded');
                    }
                    setChartData(filteredMainData);
                    setDataForDownloadExcel(filteredExcelData);
                    setSubChartData(((_j = result.sub) !== null && _j !== void 0 ? _j : []).filter(function (item) { return item !== null && item !== undefined; }));
                    setDataTotal(result.data_total || 0);
                    return [3, 6];
                case 4:
                    _a = _k.sent();
                    setStatus('error');
                    setChartData([]);
                    setSubChartData([]);
                    setDataTotal(0);
                    return [3, 6];
                case 5:
                    setIsFilterVisible(false);
                    return [7];
                case 6: return [2];
            }
        });
    }); };
    var handlePageChange = function (newPage) {
        handlePlaySound('page-change');
        if (dataTotal > 0)
            setCurrentPage(newPage);
    };
    var handlePageSizeChange = function (newPage) {
        handlePlaySound('page-size-change');
        setPageSize(newPage);
        setCurrentPage(1);
    };
    var handleShowFilter = function () {
        handlePlaySound('show-filter');
        setIsFilterVisible(true);
    };
    var handleCloseFilter = function () {
        handlePlaySound('close-filter');
        setIsFilterVisible(false);
    };
    var handleFilterApply = function (filters) {
        var mergeFilter = __assign(__assign({}, configuration.filterDashboard), filters);
        handlePlaySound('filter-applied');
        setAppliedFilters(mergeFilter);
    };
    useEffect(function () {
        var _a;
        var checkItemParameter = (_a = setup.parameters) === null || _a === void 0 ? void 0 : _a.some(function (item) {
            var _a, _b;
            if ((item === null || item === void 0 ? void 0 : item.input_type) !== 'hidden') {
                if (((_a = item === null || item === void 0 ? void 0 : item.validation) === null || _a === void 0 ? void 0 : _a.required) &&
                    (item.default === null || item.default === undefined || item.default === '') &&
                    !appliedFilters[item === null || item === void 0 ? void 0 : item.code]) {
                    setIsFilterVisible(true);
                    return true;
                }
            }
            else {
                var filtersFromDashboard = configuration.filterDashboard || {};
                if (((_b = item.validation) === null || _b === void 0 ? void 0 : _b.required) &&
                    (item.default === null || item.default === undefined || item.default === '') &&
                    item.code &&
                    !filtersFromDashboard[item.code]) {
                    setStatus('error');
                    return true;
                }
            }
            return false;
        });
        if (checkItemParameter)
            return;
        getChartDataAsync({
            id: setup.id,
            limit: setup.type === 'table' ? pageSize : undefined,
            offset: setup.type === 'table' ? (currentPage - 1) * pageSize : undefined,
        });
    }, [setup.id, setup.parameters, configuration.fnGetChartDataAsync, currentPage, pageSize, appliedFilters]);
    var renderChartComponent = function () {
        if (status !== 'loaded' || chartHeight <= 0) {
            return null;
        }
        if (isTableView) {
            return (_jsx(Table, { setup: setup, chartData: chartData, dataTotal: dataTotal, pageSize: pageSize, currentPage: currentPage, onPageChange: handlePageChange, onPageSizeChange: handlePageSizeChange }));
        }
        switch (setup.type) {
            case 'vertical-bar-chart':
            case 'horizontal-bar-chart':
                return _jsx(BarChart, { setup: setup, chartData: chartData }, index);
            case 'line-chart':
            case 'step-line-chart':
                return _jsx(LineChart, { setup: setup, chartData: chartData }, index);
            case 'pie-chart':
                return _jsx(PieChart, { setup: setup, chartData: chartData }, index);
            case 'stack-area-chart':
            case 'stack-bar-chart':
                return _jsx(StackChart, { setup: setup, chartData: chartData }, index);
            case 'percent-chart':
                return _jsx(PercentChart, { setup: setup, chartData: chartData }, index);
            case 'simple-information':
                return _jsx(SimpleInformation, { setup: setup, chartData: chartData }, index);
            case 'table':
                return (_jsx(Table, { setup: setup, chartData: chartData, dataTotal: dataTotal, pageSize: pageSize, currentPage: currentPage, onPageChange: handlePageChange, onPageSizeChange: handlePageSizeChange }));
            default:
                return _jsx("div", { children: "Unknown chart type!" }, index);
        }
    };
    var renderNoData = function () {
        if (status === 'loading') {
            if (configuration.loadingComponentChartItem)
                return configuration.loadingComponentChartItem;
            return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-loading", children: _jsx("h1", { children: "Loading chart item..." }) }));
        }
        if (status === 'empty') {
            if (configuration.emptyComponentChartItem)
                return configuration.emptyComponentChartItem;
            return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-empty", children: _jsx("h1", { children: "No data for chart item" }) }));
        }
        if (status === 'error') {
            if (configuration.errorComponentChartItem)
                return configuration.errorComponentChartItem;
            return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-error", children: _jsx("h1", { children: "Error chart item" }) }));
        }
    };
    return (_jsxs("div", { id: id, className: "s-dasboard__item ".concat(((_e = setup.tags) === null || _e === void 0 ? void 0 : _e.map(function (tag) { return "dashboard-item-tags-".concat(tag); }).join(' ')) || ''), style: {
            gridColumn: "".concat(Number(setup.x) + 1, " / span ").concat(setup.width),
            gridRow: "".concat(Number(setup.y) + 1, " / span ").concat(setup.height),
        }, onClick: function () {
            var _a;
            if (((_a = setup.target) === null || _a === void 0 ? void 0 : _a.link) && setup.target.ui_type === 'full')
                handleDashboardByLink({
                    setup: setup,
                    target: {
                        link: setup.target.link,
                    },
                    filter: appliedFilters,
                });
        }, children: [_jsx("div", { ref: titleRef, className: "s-dashboard__item--header", children: _jsx(ChartTitle, { setup: setup, onToggleView: handleToggleViewTable, handleLinkChart: handleDashboardByLink, handleDownloadExcel: downloadFileExcel, onShowFilter: handleShowFilter, appliedFilters: appliedFilters, chartData: chartData }) }), _jsxs("div", { className: "s-dashboard__item--body", style: {
                    display: setup.type === 'percent-chart' || setup.type === 'simple-information' ? 'flex' : 'block',
                    alignItems: 'center',
                    height: chartHeight,
                }, children: [renderNoData(), renderChartComponent()] }), _jsx("div", { className: "s-dashboard__item--footer", ref: subRef, children: _jsx(ChartSub, { setup: setup, subChartData: subChartData }) }), isFilterVisible && setup.parameters && setup.parameters.length > 0 && (_jsx(Filter, { parameters: setup.parameters.filter(function (param) { return param.input_type !== 'hidden'; }), onApply: handleFilterApply, onClose: handleCloseFilter, initialFilters: appliedFilters, configuration: configuration, idDashboardItem: setup.id, statusData: status, onPlaySound: handlePlaySound }))] }, index));
};
export default ChartContainer;
