var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import React, { forwardRef } from 'react';
import { FaTimes } from 'react-icons/fa';
import { convertValueTimeParameter } from '../common/utils.js';
import DatePicker from 'react-datepicker';
import 'react-datepicker/dist/react-datepicker.css';
import { vi } from 'date-fns/locale';
import { isEmpty } from '../common/utils.js';
var Filter = function (_a) {
    var parameters = _a.parameters, onApply = _a.onApply, onClose = _a.onClose, idDashboardItem = _a.idDashboardItem, initialFilters = _a.initialFilters, configuration = _a.configuration, statusData = _a.statusData, onPlaySound = _a.onPlaySound;
    var _b = React.useState({}), filterValues = _b[0], setFilterValues = _b[1];
    var _c = React.useState({}), errors = _c[0], setErrors = _c[1];
    var _d = React.useState({}), dropdownOptions = _d[0], setDropdownOptions = _d[1];
    React.useEffect(function () {
        if (initialFilters)
            setFilterValues(initialFilters);
    }, [initialFilters]);
    var hasEmptyRequiredFields = function () {
        return parameters.some(function (param) {
            var _a;
            var required = (_a = param.validation) === null || _a === void 0 ? void 0 : _a.required;
            var currentValue = filterValues[param.code];
            var hasDefault = param.default !== undefined && param.default !== null;
            if (!required || hasDefault)
                return false;
            if (param.data_type === 'integer' || param.data_type === 'double') {
                var numValue = Number(currentValue);
                return isNaN(numValue) || isEmpty(currentValue);
            }
            return isEmpty(currentValue);
        });
    };
    var validateField = function (param, value) {
        var _a;
        var hasDefaultValue = param.default !== undefined && param.default !== null;
        if ((value === undefined || value === null || value === '') && ((_a = param.validation) === null || _a === void 0 ? void 0 : _a.required) && !hasDefaultValue) {
            return 'Trường này là bắt buộc';
        }
        if (value !== undefined && value !== null && value !== '') {
            var numValue = Number(value);
            var v = param.validation || {};
            if ((param.data_type === 'integer' || param.data_type === 'double') && isNaN(numValue)) {
                return 'Giá trị không hợp lệ';
            }
            if (v.gte !== undefined && v.gte !== null && numValue < v.gte)
                return "Gi\u00E1 tr\u1ECB ph\u1EA3i \u2265 ".concat(v.gte);
            if (v.gt !== undefined && v.gt !== null && numValue <= v.gt)
                return "Gi\u00E1 tr\u1ECB ph\u1EA3i > ".concat(v.gt);
            if (v.lt !== undefined && v.lt !== null && numValue >= v.lt)
                return "Gi\u00E1 tr\u1ECB ph\u1EA3i < ".concat(v.lt);
            if (v.lte !== undefined && v.lte !== null && numValue > v.lte)
                return "Gi\u00E1 tr\u1ECB ph\u1EA3i \u2264 ".concat(v.lte);
        }
        return '';
    };
    var handleInputChange = function (code, value, dataType) {
        var _a, _b, _c, _d;
        var parsed = value;
        switch (dataType) {
            case 'integer':
                parsed = typeof value === 'string' ? parseInt(value) : value ? 1 : 0;
                break;
            case 'double':
                parsed = typeof value === 'string' ? parseFloat(value) : value ? 1 : 0;
                break;
            case 'boolean':
                parsed = Boolean(value);
                break;
            case 'datetime':
            case 'date':
                if (typeof value === 'string') {
                    var match = value.match(/^(\d{1,4})-(\d{2})-(\d{2})(T(\d{2}):(\d{2})(:(\d{2})(.(\d{1,3}))?)?)?$/);
                    if (match)
                        parsed = new Date(Number(match[1]), Number(match[2]) - 1, Number(match[3]), Number((_a = match[5]) !== null && _a !== void 0 ? _a : 0), Number((_b = match[6]) !== null && _b !== void 0 ? _b : 0), Number((_c = match[8]) !== null && _c !== void 0 ? _c : 0), Number((_d = match[10]) !== null && _d !== void 0 ? _d : 0)).toISOString();
                }
                break;
        }
        setFilterValues(function (prev) {
            var _a;
            return (__assign(__assign({}, prev), (_a = {}, _a[code] = parsed, _a)));
        });
        setErrors(function (prev) {
            var _a;
            return (__assign(__assign({}, prev), (_a = {}, _a[code] = '', _a)));
        });
    };
    var handleApply = function () {
        var newErrors = {};
        for (var _i = 0, parameters_1 = parameters; _i < parameters_1.length; _i++) {
            var param = parameters_1[_i];
            var code = param.code;
            var value = filterValues[code];
            var error = validateField(param, value);
            if (error)
                newErrors[code] = error;
        }
        if (Object.keys(newErrors).length > 0) {
            setErrors(newErrors);
            return;
        }
        var stringifiedValues = Object.fromEntries(Object.entries(filterValues).map(function (_a) {
            var key = _a[0], value = _a[1];
            if (value === null || value === undefined)
                return [key, null];
            if (typeof value === 'boolean')
                return [key, value ? 'true' : 'false'];
            return [key, String(value)];
        }));
        onApply(stringifiedValues);
    };
    var fetchDropdownOptions = function (code) { return __awaiter(void 0, void 0, void 0, function () {
        var data_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!code || dropdownOptions[code])
                        return [2];
                    if (!(configuration === null || configuration === void 0 ? void 0 : configuration.fnGetParameterDataAsync)) return [3, 2];
                    return [4, configuration.fnGetParameterDataAsync({
                            id: idDashboardItem,
                            parameter_code: code,
                        })];
                case 1:
                    data_1 = _a.sent();
                    setDropdownOptions(function (prev) {
                        var _a;
                        return (__assign(__assign({}, prev), (_a = {}, _a[code] = data_1.data.map(function (item) {
                            var _a, _b;
                            return ({
                                key: (_a = item.key) !== null && _a !== void 0 ? _a : '',
                                label: (_b = item.label) !== null && _b !== void 0 ? _b : '',
                            });
                        }), _a)));
                    });
                    _a.label = 2;
                case 2: return [2];
            }
        });
    }); };
    var renderInputField = function (param) {
        var _a, _b, _c;
        var value = (_b = (_a = filterValues[param.code]) !== null && _a !== void 0 ? _a : convertValueTimeParameter(param.default)) !== null && _b !== void 0 ? _b : '';
        var error = errors[param.code];
        var inputClass = "filter-input ".concat(error ? 'filter-input--error' : '');
        var CustomInput = forwardRef(function (_a, ref) {
            var value = _a.value, onClick = _a.onClick, placeholder = _a.placeholder, className = _a.className;
            return (_jsx("input", { type: "text", onClick: function (e) {
                    onPlaySound === null || onPlaySound === void 0 ? void 0 : onPlaySound('input-text', value);
                    onClick === null || onClick === void 0 ? void 0 : onClick(e);
                }, value: value, readOnly: true, placeholder: placeholder, className: className, ref: ref }));
        });
        React.useEffect(function () {
            if (param.input_type === 'dropdown')
                fetchDropdownOptions(param.code);
        }, [param.code]);
        switch (param.input_type) {
            case 'number':
                return (_jsx("input", { className: inputClass, type: "number", value: value === null || value === undefined || value === '' ? '' : Number(value), onChange: function (e) { return handleInputChange(param.code, e.target.value, param.data_type); }, onClick: onPlaySound ? function () { return onPlaySound(param.code, value); } : undefined }));
            case 'checkbox':
                return (_jsx("input", { className: inputClass, type: "checkbox", checked: !!value, onChange: function (e) { return handleInputChange(param.code, e.target.checked, param.data_type); }, onClick: onPlaySound ? function () { return onPlaySound(param.code, value); } : undefined }));
            case 'date':
                return (_jsx(DatePicker, { locale: vi, className: inputClass, selected: value ? new Date(value) : null, onChange: function (date) {
                        return handleInputChange(param.code, date ? date.toISOString() : '', param.data_type);
                    }, maxDate: new Date(), dateFormat: "dd/MM/yyyy", placeholderText: "DD/MM/YYYY", showYearDropdown: true, scrollableYearDropdown: true, yearDropdownItemNumber: 15, customInput: _jsx(CustomInput, { className: inputClass, placeholder: "DD/MM/YYYY" }) }));
            case 'datetime':
                return (_jsx(DatePicker, { readOnly: true, locale: vi, className: inputClass, selected: value ? new Date(value) : null, onChange: function (date) {
                        return handleInputChange(param.code, date ? date.toISOString() : '', param.data_type);
                    }, maxDate: new Date(), showTimeSelect: true, timeFormat: "HH:mm", timeIntervals: 15, dateFormat: "dd/MM/yyyy HH:mm", placeholderText: "DD/MM/YYYY HH:mm", showYearDropdown: true, scrollableYearDropdown: true, yearDropdownItemNumber: 15, customInput: _jsx(CustomInput, { className: inputClass, placeholder: "DD/MM/YYYY HH:mm" }) }));
            case 'dropdown':
                return (_jsxs("select", { className: inputClass, value: value, onChange: function (e) { return handleInputChange(param.code, e.target.value, param.data_type); }, onClick: onPlaySound ? function () { return onPlaySound(param.code, value); } : undefined, children: [_jsxs("option", { value: "", children: ["Ch\u1ECDn ", param.label] }), (_c = dropdownOptions[param.code]) === null || _c === void 0 ? void 0 : _c.map(function (opt) { return (_jsx("option", { value: opt.key, children: opt.label || opt.key }, opt.key)); })] }));
            default:
                return (_jsx("input", { className: inputClass, type: "text", value: value, onChange: function (e) { return handleInputChange(param.code, e.target.value, param.data_type); }, onClick: onPlaySound ? function () { return onPlaySound(param.code, value); } : undefined }));
        }
    };
    if (parameters.length === 0)
        return null;
    return (_jsx("div", { className: "filter-overlay", children: _jsxs("div", { className: "filter-modal", children: [_jsxs("div", { className: "filter-modal__header", children: [_jsx("p", { className: "filter-modal__header--text", children: "L\u1ECDc d\u1EEF li\u1EC7u" }), !hasEmptyRequiredFields() && statusData === 'loaded' && (_jsxs(_Fragment, { children: [_jsx("button", { className: "filter-modal__header--btn-close", onClick: onClose, children: _jsx(FaTimes, { size: 30 }) }), _jsx("div", { className: "filter-modal__header--btn-leaf" })] }))] }), _jsx("div", { className: "filter-content", children: parameters.map(function (param) {
                        var _a;
                        return (_jsxs("div", { className: "filter-item", children: [_jsxs("label", { children: [param.label || param.code, ((_a = param.validation) === null || _a === void 0 ? void 0 : _a.required) && _jsx("span", { className: "required", children: "*" })] }), _jsx("div", { className: "filter-input-wrapper", children: renderInputField(param) }), errors[param.code] && _jsx("p", { className: "filter-error", children: errors[param.code] })] }, param.code));
                    }) }), _jsx("div", { className: "filter-actions", children: _jsx("button", { className: "btn btn__primary filter-actions__accept", onClick: handleApply, children: "L\u1ECDc d\u1EEF li\u1EC7u" }) })] }) }));
};
export default Filter;
